/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package b2jlibs.graphics;

import static b2jlibs.graphics.GraphicsElement.Type.COLOR;
import static b2jlibs.graphics.GraphicsElement.Type.LINE;
import static b2jlibs.graphics.GraphicsElement.Type.RECT;
import static b2jlibs.graphics.GraphicsElement.Type.TEXT;
import java.awt.Color;
import java.awt.Paint;
import java.util.LinkedList;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author David
 */
public class GraphicsPanel extends javax.swing.JPanel {
    final public LinkedList<GraphicsElement> graphicsElementListBuffer1;
    final public LinkedList<GraphicsElement> graphicsElementListBuffer2;
    boolean backBufferIs1;
    private Color drawColor;
    
    public void addGraphicsElement(GraphicsElement e) {
        if (backBufferIs1) {
            if (graphicsElementListBuffer1!=null) {
                synchronized (graphicsElementListBuffer1) {
                    graphicsElementListBuffer1.add(e);
                }
            }
        } else {
            if (graphicsElementListBuffer2!=null) {
                synchronized (graphicsElementListBuffer2) {
                    graphicsElementListBuffer2.add(e);
                }
            }
        }
    }
    public void cls() {
        if (backBufferIs1) {
            synchronized (graphicsElementListBuffer1) {
                graphicsElementListBuffer1.clear();
            }
        } else {
            synchronized (graphicsElementListBuffer2) {
                graphicsElementListBuffer2.clear();
            }
        }
    }
    public void flip() {
        synchronized(this) {
            try {
                this.wait();
            } catch (InterruptedException ex) {}
        }
        backBufferIs1=!backBufferIs1;
    }
    
    /**
     * Creates new form GraphicsPanel
     */
    public GraphicsPanel() {
        initComponents();
        graphicsElementListBuffer1 = new LinkedList<>();
        graphicsElementListBuffer2 = new LinkedList<>();
        drawColor = Color.WHITE;
        this.setBackground(Color.BLACK);
        this.setDoubleBuffered(true);
    }
    
    @Override
    public void paintComponent(java.awt.Graphics g) {
        super.paintComponent(g);
        g.setColor(drawColor);
        
        
        if (backBufferIs1) {
            //synchronized (graphicsElementListBuffer2) {
                for (GraphicsElement e : graphicsElementListBuffer2) {
                    if (graphicsElementListBuffer2.size()==0) {
                        System.out.println("got");
                    }
                    switch (e.type) {
                        case LINE: g.drawLine(e.vals[0], e.vals[1], e.vals[2], e.vals[3]);break;
                        case RECT: g.drawRect(e.vals[0], e.vals[1], e.vals[2], e.vals[3]);break;
                        case TEXT: g.drawString(e.stringVals[0],e.vals[0], e.vals[1]+g.getFont().getSize());;break;
                        case COLOR: drawColor=new Color(e.vals[0]%256,e.vals[1]%256,e.vals[2]%256);g.setColor(drawColor);break;
                    }
                }
            //}
        } else {
            //synchronized (graphicsElementListBuffer1) {
                for (GraphicsElement e : graphicsElementListBuffer1) {
                    switch (e.type) {
                        case LINE: g.drawLine(e.vals[0], e.vals[1], e.vals[2], e.vals[3]);break;
                        case RECT: g.drawRect(e.vals[0], e.vals[1], e.vals[2], e.vals[3]);break;
                        case TEXT: g.drawString(e.stringVals[0],e.vals[0], e.vals[1]+g.getFont().getSize());break;
                        case COLOR: drawColor=new Color(e.vals[0]%256,e.vals[1]%256,e.vals[2]%256);g.setColor(drawColor);break;
                    }
                }
            //}
        }
        synchronized (this) {
            this.notify();
        }
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
}
